var $AdfStrings$$ = {};
$goog$exportSymbol$$("AdfStrings", $AdfStrings$$);
$AdfStrings$$.$COMMA$ = ",";
$goog$exportSymbol$$("AdfStrings.COMMA", $AdfStrings$$.$COMMA$);
$AdfStrings$$.$START_CURLY_BRACKET$ = "{";
$goog$exportSymbol$$("AdfStrings.START_CURLY_BRACKET", $AdfStrings$$.$START_CURLY_BRACKET$);
$AdfStrings$$.$CLOSE_CURLY_BRACKET$ = "}";
$goog$exportSymbol$$("AdfStrings.CLOSE_CURLY_BRACKET", $AdfStrings$$.$CLOSE_CURLY_BRACKET$);
$AdfStrings$$.$EQUALS$ = "\x3d";
$goog$exportSymbol$$("AdfStrings.EQUALS", $AdfStrings$$.$EQUALS$);
$AdfStrings$$.count = function $$AdfStrings$$$count$($searchString$$3$$, $matchString$$) {
  $AdfAssert$$.$assertString$($searchString$$3$$);
  $AdfAssert$$.$assertNonEmptyString$($matchString$$);
  for (var $matchCount$$ = 0, $currSearchIndex$$ = 0, $searchSize$$ = $searchString$$3$$.length, $matchSize$$ = $matchString$$.length;$currSearchIndex$$ < $searchSize$$ && ($currSearchIndex$$ = $searchString$$3$$.indexOf($matchString$$, $currSearchIndex$$), -1 != $currSearchIndex$$);) {
    $matchCount$$++, $currSearchIndex$$ += $matchSize$$;
  }
  return $matchCount$$;
};
$goog$exportSymbol$$("AdfStrings.count", $AdfStrings$$.count);
$AdfStrings$$.$initUpperCase$ = function $$AdfStrings$$$$initUpperCase$$($inString$$) {
  if (!$inString$$) {
    return $inString$$;
  }
  var $firstChar$$ = $inString$$.charAt(0), $upperFirstChar$$ = $firstChar$$.toUpperCase();
  return $firstChar$$ == $upperFirstChar$$ ? $inString$$ : $upperFirstChar$$ + $inString$$.substr(1);
};
$goog$exportSymbol$$("AdfStrings.initUpperCase", $AdfStrings$$.$initUpperCase$);
$AdfStrings$$.$createConstantName$ = function $$AdfStrings$$$$createConstantName$$($constantString_inString$$1$$) {
  $constantString_inString$$1$$ = $constantString_inString$$1$$.replace($AdfStrings$$.$_CONSTANT_REGEXP$, $AdfStrings$$.$_REPLACE_PATTERN$);
  return $constantString_inString$$1$$ = $constantString_inString$$1$$.toUpperCase();
};
$goog$exportSymbol$$("AdfStrings.createConstantName", $AdfStrings$$.$createConstantName$);
$AdfStrings$$.$toDebugString$ = function $$AdfStrings$$$$toDebugString$$($source$$15$$) {
  if (null === $source$$15$$ || void 0 === $source$$15$$) {
    return "" + $source$$15$$;
  }
  var $debugString$$ = $source$$15$$.toString();
  "[object Object]" === $debugString$$ && ($debugString$$ = $AdfStrings$$.$_toJSONString$($AdfStrings$$.$_getOwnProperties$($source$$15$$)));
  return $debugString$$;
};
$goog$exportSymbol$$("AdfStrings.toDebugString", $AdfStrings$$.$toDebugString$);
$AdfStrings$$.$isString$ = function $$AdfStrings$$$$isString$$($obj$$30$$) {
  return null != $obj$$30$$ && ("string" == typeof $obj$$30$$ || $obj$$30$$ instanceof String);
};
$goog$exportSymbol$$("AdfStrings.isString", $AdfStrings$$.$isString$);
$AdfStrings$$.trim = function $$AdfStrings$$$trim$($data$$34$$) {
  return $AdfStrings$$.$isString$($data$$34$$) ? $data$$34$$.replace($AdfStrings$$.$_TRIM_ALL_RE$, "") : $data$$34$$;
};
$goog$exportSymbol$$("AdfStrings.trim", $AdfStrings$$.trim);
$AdfStrings$$.$trimLeading$ = function $$AdfStrings$$$$trimLeading$$($data$$35$$) {
  return $AdfStrings$$.$isString$($data$$35$$) ? $data$$35$$.replace($AdfStrings$$.$_TRIM_BEGINNING_RE$, "") : $data$$35$$;
};
$goog$exportSymbol$$("AdfStrings.trimLeading", $AdfStrings$$.$trimLeading$);
$AdfStrings$$.$trimTrailing$ = function $$AdfStrings$$$$trimTrailing$$($data$$36$$) {
  return $AdfStrings$$.$isString$($data$$36$$) ? $data$$36$$.replace($AdfStrings$$.$_TRIM_ENDING_RE$, "") : $data$$36$$;
};
$goog$exportSymbol$$("AdfStrings.trimTrailing", $AdfStrings$$.$trimTrailing$);
$AdfStrings$$.startsWith = function $$AdfStrings$$$startsWith$($searchIn$$, $searchFor$$) {
  return $AdfStrings$$.$_stringStartsOrEndsWith$($searchIn$$, $searchFor$$, !0);
};
$goog$exportSymbol$$("AdfStrings.startsWith", $AdfStrings$$.startsWith);
$AdfStrings$$.endsWith = function $$AdfStrings$$$endsWith$($searchIn$$1$$, $searchFor$$1$$) {
  return $AdfStrings$$.$_stringStartsOrEndsWith$($searchIn$$1$$, $searchFor$$1$$, !1);
};
$goog$exportSymbol$$("AdfStrings.endsWith", $AdfStrings$$.endsWith);
$AdfStrings$$.$_stringStartsOrEndsWith$ = function $$AdfStrings$$$$_stringStartsOrEndsWith$$($searchIn$$2$$, $searchFor$$2$$, $i$$35_startAtBeginning$$) {
  $AdfAssert$$.$assertString$($searchIn$$2$$);
  $AdfAssert$$.$assertString$($searchFor$$2$$);
  var $searchLen$$ = $searchIn$$2$$.length, $searchForLen$$ = $searchFor$$2$$.length;
  if ($searchForLen$$ > $searchLen$$) {
    return !1;
  }
  var $increment$$ = $i$$35_startAtBeginning$$ ? 1 : -1;
  for ($i$$35_startAtBeginning$$ = $i$$35_startAtBeginning$$ ? 0 : $searchLen$$;$i$$35_startAtBeginning$$ < $searchForLen$$;$i$$35_startAtBeginning$$ += $increment$$) {
    if ($searchIn$$2$$[$i$$35_startAtBeginning$$] !== $searchFor$$2$$[$i$$35_startAtBeginning$$]) {
      return !1;
    }
  }
  return !0;
};
$AdfStrings$$.$_getOwnProperties$ = function $$AdfStrings$$$$_getOwnProperties$$($theObject$$) {
  var $ownProperties$$1$$ = {}, $k$$5$$;
  for ($k$$5$$ in $theObject$$) {
    $theObject$$.hasOwnProperty($k$$5$$) && ($ownProperties$$1$$[$k$$5$$] = $theObject$$[$k$$5$$]);
  }
  return $ownProperties$$1$$;
};
$AdfStrings$$.$_toJSONString$ = function $$AdfStrings$$$$_toJSONString$$($theObject$$1$$) {
  if ($theObject$$1$$) {
    var $keyValues$$ = [], $k$$6$$;
    for ($k$$6$$ in $theObject$$1$$) {
      $keyValues$$.push($AdfStrings$$.$_toJSONKeyValue$($k$$6$$, $theObject$$1$$[$k$$6$$]));
    }
    return "{" + $keyValues$$.join(",") + "}";
  }
  return null;
};
$AdfStrings$$.$_toJSONKeyValue$ = function $$AdfStrings$$$$_toJSONKeyValue$$($key$$30$$, $value$$103$$) {
  var $keyValueString_valueString$$;
  $keyValueString_valueString$$ = "" + $value$$103$$;
  "string" == typeof $value$$103$$ && ($keyValueString_valueString$$ = "'" + $keyValueString_valueString$$ + "'");
  return $keyValueString_valueString$$ = $key$$30$$ + ":" + $keyValueString_valueString$$;
};
$AdfStrings$$.$_CONSTANT_REGEXP$ = /([A-Z])/g;
$AdfStrings$$.$_REPLACE_PATTERN$ = "_$1";
$AdfStrings$$.$_TRIM_ALL_RE$ = /^\s*|\s*$/g;
$AdfStrings$$.$_TRIM_BEGINNING_RE$ = /^\s*/g;
$AdfStrings$$.$_TRIM_END_RE$ = /\s*$/g;
